from gi.repository import Gio, Gtk, Gdk, GdkPixbuf
from operator import lt, gt, div, mul, sub
from ScreenshotWebsite import ScreenshotWebsite
import gobject
from server.ShowmyfavesModel import Tag
from TagLayout import TagLayout
from SocialToolbar import SocialToolbar

class LayoutBookmark(Gtk.Fixed):
    def __init__(self, bookmark, listener):
        Gtk.Fixed.__init__(self)
        self.bookmark = bookmark
        self.screenshotWebsite = ScreenshotWebsite(self.bookmark.url, listener)
        self.put(self.screenshotWebsite, 30, 0)
        ## on recupere la taille de la fenetre
        self.heightThumbnail = 140
        self.widthThumbnail = 315
        
        ## On donne une taille au composant
        self.set_size_request(self.widthThumbnail, self.heightThumbnail)
        
    def imageChargee(self):
        self.eventBoxBas = Gtk.EventBox()
        self.eventBoxBas.set_size_request(self.widthThumbnail, 40)
        

        
        # Box du bas
        self.vBoxBas = Gtk.VBox()
        nomBookmark = ""
        if len(self.bookmark.name) > 30:
            nomBookmark = self.bookmark.name[:30]
        else:
            nomBookmark = self.bookmark.name 
        self.myLabel = Gtk.Label(nomBookmark)
        self.myLabel.modify_fg(Gtk.StateType.NORMAL, Gdk.color_parse("white"))
        self.vBoxBas.add(self.myLabel)
        self.eventBoxBas.add(self.vBoxBas)
 
        
        # Box du haut
        self.vBoxHaut = Gtk.VBox()
        self.btnSupprimer = Gtk.Button()
        self.imageSupprimer = Gtk.Image()
        self.imageSupprimer.set_from_file("data/media/corbeille.png")
        self.btnSupprimer.add(self.imageSupprimer)
      #  self.vBoxHaut.add(self.btnSupprimer)

        self.ev = SocialToolbar(self.bookmark)
        self.vBoxHaut.add(self.ev)
        
        # Box de gauche : etiquettes :
        self.boxEtiquette = TagLayout(self.bookmark)
        
        ## Style
        self.color = Gdk.color_parse('#6D6D6D')
        self.eventBoxBas.modify_bg(Gtk.StateType.NORMAL, self.color)

        ## on ajoute les elements
        
        self.put(self.boxEtiquette,2,0)
        self.put(self.eventBoxBas, 30, sub(self.heightThumbnail,30))
        self.put(self.vBoxHaut, sub(self.widthThumbnail,70), 5)
        self.show_all()
        
    def resizeImageKeepingRatio(self,pixbuf, width, height, eventBox):
        new_height = div(mul(pixbuf.get_height(), width), pixbuf.get_width())
        if gt(new_height, height):
            pixbuf = pixbuf.scale_simple(width, new_height, GdkPixbuf.InterpType.BILINEAR)
        elif lt(new_height, height):
            new_width = div(mul(pixbuf.get_width(), height), pixbuf.get_height())
            pixbuf = pixbuf.scale_simple(new_width, height, GdkPixbuf.InterpType.BILINEAR)
            eventBox.set_size_request(width, 30)
        else:
            pixbuf = pixbuf.scale_simple(width, height, GdkPixbuf.InterpType.BILINEAR)
        return pixbuf

