from gi.repository import Gio, Gtk
from LayoutBookmark import LayoutBookmark
from ScreenshotWebsite import ScreenshotWebsite
import gobject
import logging


class LayoutBookmarkContainer(Gtk.EventBox):

    log = logging.getLogger("LayoutBookmarkContainer")

    def __init__(self):
        Gtk.EventBox.__init__(self)
        # Variables de classe
        self.row = 0
        self.line = 0
        self.firstBookmark = True
        self.runningBookmark = 0
        self.launchLoopCreateBookmarkWithNoBookmark = 0
        self.listBookmarks = []
        
        # components grahics
        self.grille = Gtk.Grid()
        self.viewport = Gtk.Viewport()
        self.sc = Gtk.ScrolledWindow()
        self.sc.set_policy(Gtk.PolicyType.AUTOMATIC,Gtk.PolicyType.NEVER)
        
        self.viewport.add(self.grille)
        self.sc.add(self.viewport)
        self.add(self.sc)  
        self.show()
        
        # Style 
        contextViewport = self.viewport.get_style_context()
        contextViewport.add_class(Gtk.STYLE_CLASS_PRIMARY_TOOLBAR)
        contextEventBox = self.get_style_context()
        contextEventBox.add_class(Gtk.STYLE_CLASS_PRIMARY_TOOLBAR)
        
    def cleanChildren(self):
        self.listBookmarks = []
        self.firstBookmark = True
        self.launchLoopCreateBookmarkWithNoBookmark = 0
        self.line = 0
        self.row = 0
        self.runningBookmark = 0
        children = self.grille.get_children()
        for child in children : 
            self.grille.remove(child)

    def addLayoutbookmark(self, listBookmarks):
        self.listBookmarks = self.listBookmarks + listBookmarks
        if self.firstBookmark:
            self.firstBookmark = False
            self.launchLoopCreateBookmark()
        
    def launchLoopCreateBookmark(self):
        if self.runningBookmark == 0 and len(self.listBookmarks)>0:
            self.launchLoopCreateBookmarkWithNoBookmark = 0
            self.chargerScreenshot()
        elif self.runningBookmark == 0 and len(self.listBookmarks) == 0:
            self.launchLoopCreateBookmarkWithNoBookmark = self.launchLoopCreateBookmarkWithNoBookmark + 1
        if self.launchLoopCreateBookmarkWithNoBookmark < 100:
            gobject.timeout_add(100, self.launchLoopCreateBookmark)
    
    def chargerScreenshot(self):
        self.runningBookmark = self.runningBookmark + 1
        bookmark = self.listBookmarks.pop()
        self.layoutBookmark = LayoutBookmark(bookmark, self)
        self.grille.attach(self.layoutBookmark,self.row, self.line, 1, 1)
        self.layoutBookmark.show_all() 
        #is in screenshot
        if self.layoutBookmark.screenshotWebsite.isLocaleImage():
            self.layoutBookmark.screenshotWebsite.run()
        else:
            gobject.timeout_add(500, self.layoutBookmark.screenshotWebsite.run)
            gobject.timeout_add(510, self.sc.get_hadjustment().set_value, self.sc.get_hadjustment().get_upper())
    
        self.line += 1
        if self.line == 3:
            self.line = 0
            self.row += 1 

            
    def callback_screenshotLoaded(self, screenshotWebsite):
        self.runningBookmark = self.runningBookmark - 1
        self.layoutBookmark.imageChargee()
        
