from gi.repository import Gtk, Gdk, WebKit, GdkPixbuf
from operator import sub
import logging
from server import ShowmyfavesUtil
import os
import gobject
import webbrowser

class ScreenshotWebsite(Gtk.EventBox):

    def __init__(self, url, listener):
        Gtk.EventBox.__init__(self)
        print url
        self.url = url
        self.listener = listener
        self.heightThumbnail = 120
        self.widthThumbnail = 300
        self.completeTentative = 0
        self.takeShotAlreadyRun = False
        self.set_size_request(self.widthThumbnail+5,self.heightThumbnail+10)
        self.connect("button_press_event", self.openWebBrowser)
        self.connect("enter_notify_event", self.setCursorHand)
        self.connect("leave_notify_event", self.setNormalHand)
        self.listThumbnail = self.getListeThumbnail()
        
    def openWebBrowser(self, widget, event):
        webbrowser.open_new_tab(self.url)
        
    def setCursorHand(self, arg1, arg2):
        self.get_window().set_cursor(Gdk.Cursor(Gdk.CursorType.HAND2))
        
    def setNormalHand(self, arg1, arg2):
        self.get_window().set_cursor(None)
   
    def transformationUrl(self, url):
        self.isHttp = url.find("http://", 0, 20)  
        self.isHttps = url.find("https://", 0, 20)  
        if self.isHttp >= 0 :
            self.urlCoupee = url[4:20]      
        elif self.isHttps >= 0:
            self.urlCoupee = url[5:20]
        else:
            self.urlCoupee = url
            
        return ''.join(self.e for self.e in self.urlCoupee if self.e.isalnum())
    
    def getListeThumbnail(self):
        self.config = ShowmyfavesUtil.ConfigLoader.load()
        self.dossierThumbnail = self.config.THUMBNAIL_FOLDER
        self.dossierThumbnail = self.dossierThumbnail
        return os.listdir(self.dossierThumbnail)
        
    def isLocaleImage(self):
        self.urlImage = self.transformationUrl(self.url)
        return self.urlImage in self.listThumbnail
    
    def run(self):
        self.image = Gtk.Image();
        if self.isLocaleImage():
            self.image.set_from_file(self.dossierThumbnail+"/"+self.urlImage)
            self.image.show()
            self.add(self.image) 
            self.listener.callback_screenshotLoaded(self)
        else:
            self.webView = WebKit.WebView()
            self.webView.connect("load-finished", self.loadComplete)
            self.webView.connect("load-error", self.loadError)
            
            self.scrolledWindow = Gtk.ScrolledWindow()
            self.scrolledWindow.set_policy(Gtk.PolicyType.NEVER,Gtk.PolicyType.NEVER)
            self.scrolledWindow.set_size_request(self.widthThumbnail+5,self.heightThumbnail+10)

            self.webView.set_size_request(self.widthThumbnail,self.heightThumbnail)
            self.webView.set_full_content_zoom(True)
            self.webView.load_uri(self.url)

            self.webView.zoom_out()
            self.webView.zoom_out()
            self.webView.zoom_out()
            self.webView.zoom_out()
            self.webView.zoom_out()
            self.webView.zoom_out()
            self.webView.zoom_out()
            self.webView.zoom_out()
            self.webView.show()
    
            self.scrolledWindow.add(self.webView)
            self.scrolledWindow.show()
            self.add(self.scrolledWindow)
            
            #if after 3sc the site isn't loaded, stop it
            gobject.timeout_add(5000, self.checkProgress)
        
#        self.webView.connect("load-started", self.loadStarted)
#        self.webView.connect("load-committed", self.loadCommitted)

    def checkProgress(self):
        self.loadComplete(None, None)

    def loadComplete(self, widget, event):
        if self.webView.get_window():
            if not self.takeShotAlreadyRun:
                self.takeShotAlreadyRun = True
                gobject.timeout_add(100, self.takeShot)
        elif self.completeTentative == 3 and not self.takeShotAlreadyRun:
            gobject.timeout_add(1000, self.takeShot)
        else:
            self.completeTentative += 1
            gobject.timeout_add(500, self.loadComplete, None, None)            

    def takeShot(self):
        if self.webView.get_window():
            self.pixbuf = Gdk.pixbuf_get_from_window(self.webView.get_window(),Gtk.WindowPosition.NONE,Gtk.WindowPosition.NONE,sub(self.widthThumbnail,5), self.heightThumbnail)
            self.pixbuf = self.pixbuf.scale_simple(self.widthThumbnail+15, self.heightThumbnail+30, GdkPixbuf.InterpType.BILINEAR)
            self.pixbuf.savev(self.dossierThumbnail+"/"+self.urlImage,"png",[],[])
            gobject.timeout_add(1000, self.switchWebkitToImage)
        else:
            self.switchWebkitToImage()
        
    def switchWebkitToImage(self):
        self.image.set_from_pixbuf(self.pixbuf)
        self.remove(self.scrolledWindow)
        self.add(self.image)
        self.image.show()
        gobject.timeout_add(500, self.listener.callback_screenshotLoaded, self)
        
    def loadError(self, widget, event, error1, error2):
        print "error" + str(error1) + " / " + str(error2)
        
    def loadStarted(self, widget, event):
        print "started"
        
    def loadCommitted(self, widget, event):
        print "committed"
    
    
        
if __name__ == '__main__':
    client = ScreenshotWebsite("http://facebook.com")
    w= Gtk.Window()
    heightThumbnail = 300
    widthThumbnail = 150
    w.set_size_request(heightThumbnail,widthThumbnail)
    fixed = Gtk.Fixed()
    grille = Gtk.Grid()
    viewport = Gtk.Viewport()
    ev = Gtk.EventBox()
    vb = Gtk.VBox()
    sc = Gtk.ScrolledWindow()
    sc.set_policy(Gtk.PolicyType.NEVER,Gtk.PolicyType.NEVER)
    fixed.put(client,0,0)
    
    viewport.add(grille)
    sc.add(viewport)
    ev.add(sc)
    
    w.add(ev)
    grille.attach(fixed, 0, 0, 1, 1)
    
    client2 = ScreenshotWebsite("http://stackoverflow.com")
    grille.attach(client2, 1, 1, 1, 1)
    
    w.show_all()
    client.run()
    client2.run()
    Gtk.main()
    

