from gi.repository import Gtk, Gdk
from server.ShowmyfavesModel import Tag
from server.ShowmyfavesFactoryCommand import FactoryCommand
from server.ShowmyfavesClient import Client

class TagGraphic(Gtk.EventBox):

    def __init__(self, tag):
        Gtk.EventBox.__init__(self)
        self.tag = tag
        self.isSelected = False
        self.set_size_request(25,15)
        self.set_border_width(2)
        self.modify_bg(Gtk.StateType.NORMAL, Gdk.color_parse(self.tag.color))
        self.modify_bg(Gtk.StateType.SELECTED, Gdk.color_parse("#FF0000"))
        self.set_tooltip_text(self.tag.name)
        self.connect("button_press_event",self.etiquetteClick)
        self.connect("enter_notify_event", self.setCursorHand)
        self.connect("leave_notify_event", self.setNormalHand)
        
    def etiquetteClick(self, widget, event):
        if self.isSelected:
            self.isSelected = False
            self.set_state(Gtk.StateType.NORMAL)
            FactoryCommand.INSTANCE().tags.remove(self.tag.name)
        else:
            self.isSelected = True
            self.set_state(Gtk.StateType.SELECTED)
            FactoryCommand.INSTANCE().tags.append(self.tag.name)
        Client.INSTANCE.listner.cleanChildren()
        Client.INSTANCE.sendCommand(FactoryCommand.makeGetNbBookmarks())
        Client.INSTANCE.sendCommand(FactoryCommand.makeGetBookmarks())
        
    def setCursorHand(self, arg1, arg2):
        self.get_window().set_cursor(Gdk.Cursor(Gdk.CursorType.HAND2))
        
    def setNormalHand(self, arg1, arg2):
        self.get_window().set_cursor(None)
