# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
### BEGIN LICENSE
# Copyright (C) 2012 m@n <rmaneschi@gmail.com>
# This program is free software: you can redistribute it and/or modify it 
# under the terms of the GNU General Public License version 3, as published 
# by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but 
# WITHOUT ANY WARRANTY; without even the implied warranties of 
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
# PURPOSE.  See the GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License along 
# with this program.  If not, see <http://www.gnu.org/licenses/>.
### END LICENSE

import optparse

import gettext
from gettext import gettext as _
gettext.textdomain('showmyfaves')

from gi.repository import Gtk, Gdk # pylint: disable=E0611
import gobject
import logging
import signal

from sys import executable
from os import system, kill
from subprocess import Popen
from threading import Thread

from showmyfaves import ShowmyfavesWindow
from showmyfaves_lib import set_up_logging, get_version

def parse_options():
    """Support for command line options"""
    parser = optparse.OptionParser(version="%%prog %s" % get_version())
    parser.add_option(
        "-v", "--verbose", action="count", dest="verbose",
        help=_("Show debug messages (-vv debugs showmyfaves_lib also)"))
    (options, args) = parser.parse_args()

    set_up_logging(options)

def main():
    'constructor for your class instances'
    parse_options()
    
    # Server start
#    serverThread = Thread(target=system("python2 ./showmyfaves/server/ShowmyfavesServer.py"))
#    serverThread.start()
    p = Popen([executable, "./showmyfaves/server/ShowmyfavesServer.py"])
    pid = p.pid
    
    # Run the application.
    gobject.threads_init()

    window = ShowmyfavesWindow.ShowmyfavesWindow()
    window.show_all()
    Gtk.main()  
    
    # Server stop
    kill(int(pid), signal.SIGKILL)
