import json
import logging
import os
import sys

import ParsersUtil

from ShowmyfavesModel import Bookmark, Tag 

log = logging.getLogger('chromium_18')

def Parse(params):
    bookmarkFile = os.path.expanduser('~') + ("/.config/chromium/Default/Bookmarks")
    json_data = None
    try:
        json_data = open(bookmarkFile)
        data = json.load(json_data)
        roots = data["roots"]["bookmark_bar"]
        return parserRecursif(params, roots, [Tag("navigator", "chromium")])
    except IOError as e:
        print 'no chromium avalaible'
    return []

def parserRecursif(params, rootNode, tags):
    bookmarks = []
    myTags = []
    myTags = myTags + tags
    if "children" in rootNode:
        myTags.append(Tag("folder", rootNode["name"]))
        for child in rootNode["children"]:
            bookmarks += parserRecursif(params, child, myTags)
    else:
        bookmark = Bookmark(rootNode["name"], rootNode["url"], rootNode["date_added"], "", myTags)
        if ParsersUtil.testTags(bookmark, params) and ParsersUtil.testFilter(bookmark, params):
            bookmarks.append(bookmark)
    return bookmarks
    
if __name__ == '__main__':
    logging.basicConfig(level=logging.INFO)
    data = Parse();
    log.info(data);
