import sqlite3
import logging
import os
import sys

import ParsersUtil

from ShowmyfavesModel import Bookmark, Tag 

log = logging.getLogger('firefox_2')

def Parse(params):
    homedir = os.path.expanduser('~') + '/.mozilla/firefox/'
    sqliteFile = ""
    mapBookmark = {}
    dirs = os.listdir(homedir)
    for fname in dirs:
        if fname.endswith(".default"):
            sqliteFile = homedir + fname + '/places.sqlite'
            pass        
    sqliteConn = sqlite3.connect(sqliteFile)
    c = sqliteConn.cursor()
    c.execute("select distinct moz_bookmarks.id, moz_bookmarks.title, moz_places.url, moz_bookmarks.dateAdded, moz_bookmarks.parent from moz_places left join  moz_bookmarks on moz_places.id = moz_bookmarks.fk where moz_bookmarks.title is not NULL and moz_bookmarks.type = 1 and moz_places.url not like 'place:%' order by moz_bookmarks.lastModified;")
    
    bookmarks = []
    for row in c:
        tags = [Tag.getTag("navigator", "firefox")]
        loadTags(tags, sqliteConn, row[4])
        bookmark = Bookmark(row[1], row[2], row[3], "", tags)
        mapBookmark[row[0]] = bookmark
        if ParsersUtil.testTags(bookmark, params) and ParsersUtil.testFilter(bookmark, params):
            bookmarks.append(bookmark)
    #load description
    c.execute("select moz_bookmarks.id, moz_items_annos.content from moz_bookmarks, moz_places, moz_items_annos where moz_places.id = moz_bookmarks.fk and moz_bookmarks.type = 1 and moz_bookmarks.id = moz_items_annos.item_id and moz_items_annos.anno_attribute_id = 1 order by moz_bookmarks.lastModified;")
    for row in c:
        if row[0] in mapBookmark:
            mapBookmark[row[0]].description = row[1]
    sqliteConn.close()
    return bookmarks
    
def loadTags(tags, sqliteConn, parentId):
    c = sqliteConn.cursor()
    c.execute("select moz_bookmarks.parent, moz_bookmarks.title from moz_bookmarks where moz_bookmarks.id = "+str(parentId)+";")
    for row in c:
        tags.append(Tag.getTag("folder", row[1]))
        if row[0] > 1:
            loadTags(tags, sqliteConn, row[0])
    
if __name__ == '__main__':
    logging.basicConfig(level=logging.INFO)
    data = Parse();
    log.info(data[0]);
